name = "File Sysytem"
desc = "File Systems"
 
from gtk import *
from GTK import *
import re 
import os 
import sys
from utils import *
 
#Still needed:
#The output of mount (and umount) should be trapped and returned
#Mount can demand a password
#click on add to fstab unwritten
#click on edit unwritten
#click on delete unlinked

#would be nice:
#move add entry to a seperate screen
#allow clicking on an entry to bring up a mount/delete/edit button screen
#some way to kill save button, not appropriate?

#for future do modprobe

#window has name/type/filesystems/status
#set def options based on type




class applet(Applet): 
    def unmount(self, target):
        self.debug('unmount: %s' %target)
	fin = os.popen4('umount %s'%target)[1]
	data = fin.read()
	fin.close()
	if 1<len(data) :
	  self.errormessage(data)
        return len(data)

    def mount(self, target):	
        self.debug('mount: %s' %target)
        fin = os.popen4('mount %s'%target)[1]
	data = fin.read()
	fin.close()
	if 1<len(data) :
	  self.errormessage(data)
	return len(data)

    def select_row(self, a, row, col, event):
        self.debug('select_row: %s %s %s' % (row, col, event))
	self.interest=[row]
#	ungray all buttons

    def unselect_row(self, a, row, col, event):
        self.debug('unselect_row')
	self.interest=[]
#	gray all buttons

    def call_add(self, button):
        self.debug('call_add')
	self.editwin()

    def call_edit(self, button):
	if 0!= len (self.interest[:]):
	    self.editwin(self.fstab[self.interest[0]])
 
    def call_delete(self, button):
        self.debug('call_delete')
#	self.errormessage('Wont Delete')
	if 0 != len(self.interest[:]):
	    i = self.interest[0]
	    a = self.fstab[i]
	    self.fstab[i:i+1] = [];
	    self.mycl.remove(i)
            self.changedfstab = 1
	else:
	    self.errormessage('Select Something!')

    def cancel_edit(self, button):
        self.debug('cancel_edit')
	self.newwindow.hide()

    def addfstab(self, button):
        self.debug('addfstab')
        mountinfo = (self.filesystem.get_text(), self.mountpoint.get_text(), self.filetype.get_text(), self.options.get_text(), self.freq.get_text(), self.fsckpass.get_text(), 'P', 'unmounted')
	self.fstab.append(mountinfo)
	self.mycl.append((mountinfo[0], mountinfo[1], mountinfo[2], mountinfo[7], mountinfo[6]))
        self.changedfstab = 1
	self.newwindow.hide()
	self.redraw()

    def replacefstab(self, button):
        self.debug('replacefstab')
        i = self.interest[0]
        self.debug('@%s' % i)
	a = self.fstab[i]
        self.debug('!')
        mountinfo = (self.filesystem.get_text(), self.mountpoint.get_text(), self.filetype.get_text(), self.options.get_text(), self.freq.get_text(), self.fsckpass.get_text(), a[6], a[7])
        self.debug('#')
	if 'mounted' == a[7] :
 	   self.unmount(a[1])
	self.fstab[i] = mountinfo;
	self.mycl.insert(i, (mountinfo[0], mountinfo[1], mountinfo[2], a[7], a[6]))
	self.mycl.remove(i+1)
        self.changedfstab = 1
        self.debug('&')
	self.newwindow.hide()
	self.redraw()

    def errormessage(self, message):
        self.debug('errormessage')
        errwin = GtkDialog()
        errbox = errwin.vbox
        errwin.set_name('Error')
#        errwin.set_border_width(10);
        errwin.popup(20, 20)
#        errwin.set_usize(120, 120)
        errwin.connect ("delete_event", self.destroy)
        errwin.connect ("destroy", self.destroy)
        errwin.activate_focus()
        hbox = GtkHBox()
        lbl = GtkLabel(message) 
        hbox.pack_start(lbl,expand=FALSE) 
        lbl.show() 
	errbox.pack_start(hbox,expand=FALSE) 
	hbox.show()
        hbox2 = GtkHBox()
        button2=GtkButton(label='OK')
        button2.connect('clicked', self.kill_win, errwin)
        hbox2.pack_start(button2, fill=FALSE, expand=TRUE)
	button2.show() 
	errbox.pack_start(hbox2,expand=FALSE) 
	hbox2.show()
	errbox.show()
	errwin.show()

    def kill_win(self, button, data) :
	data.hide()

    def editwin(self, mountinfo=None):
        self.debug('editwin')
        self.newwindow = GtkDialog()
        self.windowbox = self.newwindow.vbox
	if mountinfo:
            self.newwindow.set_name(mountinfo[1])
	else:
            self.newwindow.set_name('New Entry')
#        self.newwindow.set_border_width(10);
        self.newwindow.popup(20, 20)
#        self.newwindow.set_usize(120, 120)
        self.newwindow.connect ("delete_event", self.destroy)
        self.newwindow.connect ("destroy", self.destroy)
        self.newwindow.activate_focus()
#        self.get_toplevel().add(self.newwindow)

        hbox = GtkHBox()
	if mountinfo:
            lbl = GtkLabel('Edit Window') 
	else:
            lbl = GtkLabel('Add Window') 
        hbox.pack_start(lbl,expand=FALSE) 
        lbl.show() 
	self.windowbox.pack_start(hbox,expand=FALSE) 
	hbox.show()


        hbox = GtkHBox()
        lbl=GtkLabel('Mount Point:') 
        hbox.pack_start(lbl,expand=FALSE) 
        lbl.show() 
        self.mountpoint = GtkEntry()
	if mountinfo:
            self.mountpoint.set_text(mountinfo[1])
	else:
            self.mountpoint.set_text('')
        hbox.pack_end(self.mountpoint)
	self.mountpoint.show()
	self.windowbox.pack_start(hbox, expand=FALSE)
	hbox.show()

        hbox = GtkHBox()
        lbl=GtkLabel('Filesystem:') 
        hbox.pack_start(lbl,expand=FALSE) 
        lbl.show() 
        self.filesystem = GtkEntry()
	if mountinfo:
            self.filesystem.set_text(mountinfo[0])
	else:
            self.filesystem.set_text('')
        hbox.pack_end(self.filesystem)
	self.filesystem.show()
	self.windowbox.pack_start(hbox, expand=FALSE)
	hbox.show()

        hbox = GtkHBox()
        lbl=GtkLabel('Type:') 
        hbox.pack_start(lbl,expand=FALSE) 
        lbl.show() 
        self.filetype = GtkEntry()
	if mountinfo:
            self.filetype.set_text(mountinfo[2])
	else:
            self.filetype.set_text('')
        hbox.pack_start(self.filetype)
	self.filetype.show()
        lbl=GtkLabel('Freq:') 
        hbox.pack_start(lbl,expand=FALSE) 
        lbl.show() 
        self.freq = GtkEntry()
	if mountinfo:
            self.freq.set_text(mountinfo[4])
	else:
            self.freq.set_text('0')
        hbox.pack_start(self.freq)
	self.freq.show()
        lbl=GtkLabel('Pass:') 
        hbox.pack_start(lbl,expand=FALSE) 
        lbl.show() 
        self.fsckpass = GtkEntry()
	if mountinfo:
            self.fsckpass.set_text(mountinfo[5])
	else:
            self.fsckpass.set_text('0')
        hbox.pack_start(self.fsckpass)
	self.fsckpass.show()
	self.windowbox.pack_start(hbox, expand=FALSE)
	hbox.show()

        hbox = GtkHBox()
        lbl=GtkLabel('Options:') 
        hbox.pack_start(lbl,expand=FALSE) 
        lbl.show() 
        self.options = GtkEntry()
	if mountinfo:
            self.options.set_text(mountinfo[3])
	else:
            self.options.set_text('defaults')
        hbox.pack_end(self.options)
	self.options.show()
	self.windowbox.pack_start(hbox, expand=FALSE)
	hbox.show()

        hbox = GtkHBox(FALSE)
        lbl=GtkLabel('') 
        hbox.pack_start(lbl, fill=FALSE, expand=TRUE)
        lbl.show() 
	if mountinfo:
            button1=GtkButton(label='Replace')
            button1.connect('clicked', self.replacefstab)
	else:
            button1=GtkButton(label='Add')
            button1.connect('clicked', self.addfstab)

        hbox.pack_start(button1, fill=FALSE, expand=TRUE)
	button1.show() 
        button2=GtkButton(label='Cancel')
        button2.connect('clicked', self.cancel_edit)
        hbox.pack_start(button2, fill=FALSE, expand=TRUE)
	button2.show() 
        lbl=GtkLabel('') 
        hbox.pack_start(lbl, fill=FALSE, expand=TRUE)
        lbl.show() 
	self.windowbox.pack_start(hbox, expand=FALSE)
	hbox.show()

	self.windowbox.show()
	self.newwindow.show()

         
    def callback_mount(self, button1):
	self.debug('1')  
	if 0!= len (self.interest[:]):
	   self.debug('2')  
	   data = self.interest[0]
  	   if 3 > self.mount(self.fstab[data][1]) :
	      self.debug('3 data: %s'%data)  
  	      self.fstab[data][7] = 'mounted'
	      self.mycl.set_text(data, 3, 'mounted')
	      self.debug('5    :%s' %self.mycl.get_text(data, 3) )  
	   self.debug('6')  
           self.redraw()
        self.debug('7')  

    def callback_unmount(self, button1):
	self.debug('1')  
	if 0!= len (self.interest[:]):
	   self.debug('2')  
	   data = self.interest[0]
  	   if 3 > self.unmount(self.fstab[data][1]) :
	      self.debug('3 data: %s'%data)  
  	      self.fstab[data][7] = 'unmounted'
	      self.mycl.set_text(data, 3, 'unmounted')
	      self.debug('5')  
	   self.debug('6')  
           self.redraw()
        self.debug('7')  

    def debugstart(self):
	sys.stdout.flush()
	sys.stderr.flush()
	print '\n\n\n\n\n\n\n\n'
	sys.stdout.flush()
        self.add(self.dbox) 
        self.dbox.show() 

    def debug(self, text):
        if self.dbox:
            print text
	    sys.stderr.flush()
	    hb = GtkHBox(homogeneous=FALSE)
            lbl = GtkLabel(str(text)) 
            hb.pack_start(lbl,expand=FALSE)
            self.dbox.pack_start(hb,expand=FALSE) 
            lbl.show() 
            hb.show() 

    def redraw(self):
        self.box = GtkVBox() 
        self.add(self.box) 
        self.box.show() 

        lbl = GtkLabel('Networked File Systems') 
        self.box.pack_start(lbl,expand=FALSE) 
        lbl.show() 

        self.box.pack_start(self.mycl,expand=FALSE) 

        self.box.pack_start(self.mycl, TRUE, TRUE, 0)
        self.mycl.show() 

        hbox = GtkHBox()
	self.box.pack_start(hbox, FALSE, TRUE, 0)
	hbox.show()

        hb = GtkHBox(FALSE) 
        hb2 = GtkHBox(FALSE) 
        button1=GtkButton(label='Mount')
        hb2.pack_start(button1, fill=FALSE, expand=FALSE)
        button2=GtkButton(label='Unmount')
        hb2.pack_start(button2, fill=FALSE, expand=FALSE)
	button1.signal_connect('clicked', self.callback_mount)
	button2.signal_connect('clicked', self.callback_unmount)
	button1.show() 
	button2.show() 
	hb2.show()
	hb.pack_start(hb2, fill=FALSE, expand=TRUE)
        button3=GtkButton(label='Add')
        hb.pack_start(button3, fill=FALSE, expand=TRUE)
	button3.signal_connect('clicked', self.call_add)
	button3.show() 
        button4=GtkButton(label='Delete')
        hb.pack_start(button4, fill=FALSE, expand=TRUE)
	button4.signal_connect('clicked', self.call_delete)
	button4.show() 
        button5=GtkButton(label='Edit')
        hb.pack_start(button5, fill=FALSE, expand=TRUE)
	button5.signal_connect('clicked', self.call_edit)
	button5.show() 
  	self.box.pack_start(hb,expand=FALSE) 

        self.errorlbl = GtkLabel('') 
        self.box.pack_start(self.errorlbl,expand=FALSE) 
        self.errorlbl.show() 
        hb.show() 
        self.box.show()

 
    def __init__(self): 
 
        Applet.__init__(self) 

        self.dbox = GtkVBox() 
#	self.debugstart()

        self.interest=[]
        self.fstab=[]
        lineparseftab = re.compile('^([^ \t]+)[ \t]+([^ \t]+)[ \t]+([^ \t]+)[ \t]+([^ \t]+)[ \t]+([^ \t]*)[ \t]+([^ \t]*)[ \t\n]$', re.IGNORECASE)

        fin = open('/etc/fstab', 'r')  
        while 1:
           lines = fin.readlines(8*1024)
           if not lines: break
           for line in lines:
		foundgoodline = lineparseftab.search(line)
         	if foundgoodline:
		   self.debug('fstab: %s %s' %(foundgoodline.group(1), foundgoodline.group(2)))
                   a = [foundgoodline.group(1), foundgoodline.group(2), foundgoodline.group(3), foundgoodline.group(4), foundgoodline.group(5), foundgoodline.group(6), 'P', 'unmounted']
		   self.fstab.append(a)
        fin.close()

        fin2 = open('/proc/mounts', 'r')  
        while 1:
           lines = fin2.readlines(8*1024)
           if not lines: break
           for line in lines:
		foundgoodline = lineparseftab.search(line)
         	if foundgoodline:
                   a = [foundgoodline.group(1), foundgoodline.group(2), foundgoodline.group(3), foundgoodline.group(4), foundgoodline.group(5), foundgoodline.group(6), 'T', 'mounted']
		   foundit = 0
        	   for i in range(len(self.fstab[:])):
	              b = self.fstab[i]
	              if (b[0] == a[0])&(b[1] == a[1]):
			foundit=1
			self.fstab[i][7] = 'mounted';
        	   if 0 == foundit:
			self.fstab.append(a)
        fin2.close()

	self.mycl = GtkCList(5, ('Device', 'mnt pt', 'type', 'status', 'T'))
	for i in self.fstab[:]:
	    if 8==len(i):
                self.mycl.append((i[0], i[1], i[2], i[7], i[6]))
        self.mycl.set_column_width(0, 70)
        self.mycl.set_column_width(1, 70)
        self.mycl.set_column_width(2, 30)
        self.mycl.set_column_width(3, 30)
        self.mycl.set_column_width(4, 10)
#	self.mycl.set_selection_mode(GTK_SELECTION_SINGLE)
	self.mycl.signal_connect('select_row', self.select_row)
	self.mycl.signal_connect('unselect_row', self.unselect_row)

	self.redraw()
#	self.editwin(self.fstab[3])

    def save(self,msgbox=FALSE): 
        import os 


        fout = open('/etc/fstab.new', 'w')
	for a in self.fstab[:] :
	   if 'P' == a[6]:
              fout.write('%s\t\t%s\t%s\t%s\t%s %s\n' % (a[0], a[1], a[2], a[3], a[4], a[5]))
        fout.close() 

        ret = Applet.save(self,msgbox) 
 
applet_instance = applet() 
