name = "Timezone"
desc = "Set System's Timezone"

from gtk import *
from GTK import *

from utils import *

_timezones = "/etc/timezones/"
_zonelink = "/etc/localtime"
 
class applet(Applet):
    def __init__(self):
        import string
        import os

        Applet.__init__(self)
        self.box = GtkVBox()
        self.add(self.box)
        self.box.show()

        lbl = GtkLabel('System Timezone')
        self.box.pack_start(lbl,expand=FALSE)
        lbl.show()

	try:
		zonefile = os.readlink(_zonelink)
		self.current=os.path.split(zonefile)[1]
	except:
		self.current=""
        print "Current is:", self.current

	self.zones = GtkList()
	for zone in os.listdir("/etc/timezones/"):
	    zoneitem = GtkListItem(zone)
            zoneitem.show()
            zoneitem.set_data("timezone", zone)
            zoneitem.connect("select", self.OnSelect)
            if zone == self.current:
                select_item = zoneitem
	    self.zones.add(zoneitem)
	select_item.select()

        self.box.pack_start(self.zones)
        self.zones.show()

    def OnSelect(self, widget):
	self.current = widget.get_data("timezone")
        print "Select:", self.current

    def save(self,msgbox=FALSE):
        import os
	try: os.unlink(_zonelink)
	except: pass
	try: os.symlink(os.path.join(_timezones, self.current), _zonelink)
	except: pass
        ret = Applet.save(self,msgbox)
        
applet_instance = applet()
