name = "Kernel Modules"
desc = "Kernel Modules"
 
from gtk import *
from GTK import *
import re 
import os 
import sys
from utils import *
 


class applet(Applet): 
    def rmmod(self, target):
        self.debug('rmmod: %s' %target)
	fin = os.popen4('rmmod %s'%target)[1]
	data = fin.read()
	fin.close()
	if 1<len(data) :
	  self.errormessage(data)
        return len(data)

    def inittree(self):
        self.debug('inittree')
        parsemodprobe = re.compile('^/[^/]+/[^/]+/[^/]+/(.*/)([^/]+).o$', re.IGNORECASE)
	fin = os.popen4('/sbin/modprobe -l')[1]
        self.debug('A: %s' %fin)
	self.noofmods=0
        while 1:
           lines = fin.readlines(8*1024)
           if not lines: break
           for line in lines:
#              self.debug('  {%s}' % line)
	      foundgoodline = parsemodprobe.search(line)
              if foundgoodline:
#	         self.debug('loaded: %s %s' %(foundgoodline.group(1), foundgoodline.group(2)))
                 a = [foundgoodline.group(1), foundgoodline.group(2)]
                 self.addcl.append(a)
	         self.noofmods = self.noofmods + 1
#                 self.debug('  %s  %s' % (foundgoodline.group(2), foundgoodline.group(1)))
        fin.close()

    def initbasedir(self):
	fin = os.popen4('modprobe -l')[1]
	data = fin.read()
        locale = re.compile('^(/[^/]+/[^/]+/[^/]+)', re.IGNORECASE)
	foundlocale = locale.search(data)
        if foundlocale:
	   self.debug('locale: %s' % foundlocale.group(1))
           self.basedir = foundlocale.group(1)


    def call_insmod(self, button):
        self.debug('call_insmod')
        dontabort = 0
	toadd = ''
        if 0!= len (self.interest2[:]):
	   self.debug('a')
           data = self.interest2[0]
	   self.debug('b')
  	   self.debug('data=%s [%s]' % (data, self.addcl.get_text([data][0],1)))
	   self.debug('c')
  	   toadd = self.addcl.get_text([data][0],1)
	   self.debug('d')
	else:
	   self.debug('e')
	   requested = self.searchname.get_text()
	   if requested != '':
  	      self.debug('f')
  	      if None == re.compile("[*?]").match(requested):
  	         self.debug('f2')
	         for i in range(self.noofmods):
		    self.debug('g %s' %  self.addcl.get_text(i,1))
		    if self.addcl.get_text(i,1) == requested:
		       self.debug('h')
		       toadd = requested
                 if toadd == '':
	            requested = requested + '*'
              if toadd == '':
	         requested = re.compile("[*]").sub('.*', requested)
	         requested = re.compile("[?]").sub('.*', requested)
                 requested = '^' + requested + '$'
		 self.debug('searching for [%s]' % requested)
		 find = re.compile(requested)
		 found = []
	         for i in range(self.noofmods):
		    self.debug('g2 %s' %  self.addcl.get_text(i,1))
		    if find.search(self.addcl.get_text(i,1)):
		       self.debug('h')
		       found.append(i)
		 if 0==len(found[:]) :
		    self.errormessage('Can\'t find module %s*' % self.searchname.get_text())
		    dontabort = 1
		 if 1==len(found[:]) :
		    toadd = self.addcl.get_text(found[0],1)
		 if 1<len(found[:]) :
		    messgerr = 'Found more than one match.\nSearches for module names only load modules\nIf there is exactly one match\nMatches include:\n'
		    for i in found:
			messgerr = messgerr + self.addcl.get_text(i,0) + '/' + self.addcl.get_text(i,1) + '\n'
		    self.errormessage(messgerr)
		    dontabort = 1
	if toadd != '':
           self.insmod(toadd)
	if 0 == dontabort:
           self.newwindow.hide()
	   self.initloaded()
           self.box.show()
 
    def insmod(self, target):	
        self.debug('insmod: %s' %target)
        fin = os.popen4('insmod %s'%target)[1]
	data = fin.read()
	fin.close()
	self.initloaded()
	if 1<len(data) :
	  self.errormessage(data)
	return len(data)

    def select_row(self, a, row, col, event):
        self.debug('select_row: %s %s %s' % (row, col, event))
	self.interest=[row]
#	ungray all buttons

    def select_add_row(self, a, row, col, event):
        self.debug('select_row: %s %s %s' % (row, col, event))
	self.interest2=[row]
#	ungray all buttons

    def unselect_row(self, a, row, col, event):
        self.debug('unselect_row')
	self.interest=[]
#	gray all buttons

    def unselect_add_row(self, a, row, col, event):
        self.debug('unselect_row')
	self.interest=[]
#	gray all buttons

    def call_add(self, button):
        self.debug('call_add')
	self.addwin()

    def cancel_edit(self, button):
        self.debug('cancel_edit')
	self.newwindow.hide()
	self.box.show()

    def errormessage(self, message):
        self.debug('errormessage')
        errwin = GtkDialog()
        errbox = errwin.vbox
        errwin.set_name('Error')
#        errwin.set_border_width(10);
        errwin.popup(20, 20)
#        errwin.set_usize(120, 120)
        errwin.connect ("delete_event", self.destroy)
        errwin.connect ("destroy", self.destroy)
        errwin.activate_focus()
        scrolled_window = GtkScrolledWindow()
        scrolled_window.set_policy (POLICY_AUTOMATIC, POLICY_AUTOMATIC);
        vbox = GtkHBox()
        lbl = GtkLabel(message) 
        vbox.pack_start(lbl,expand=FALSE) 
        lbl.show() 
	scrolled_window.add_with_viewport(vbox)
	vbox.show()
	errbox.pack_start(scrolled_window, TRUE, TRUE, 0)
        scrolled_window.show()
        hbox2 = GtkHBox()
        button2=GtkButton(label='OK')
        button2.connect('clicked', self.kill_win, errwin)
        hbox2.pack_start(button2, fill=FALSE, expand=TRUE)
	button2.show() 
	errbox.pack_start(hbox2,expand=FALSE) 
	hbox2.show()
	errbox.show()
	errwin.show()

    def kill_win(self, button, data) :
	data.hide()

    def addwin(self):
	self.box.hide()
	self.newwindow.show()

    def makeaddwin(self):
        self.debug('makeaddwin')
        self.newwindow = GtkDialog()
        self.windowbox = self.newwindow.vbox
        self.newwindow.set_name('Select new Module')
#        self.newwindow.set_border_width(10);
        self.newwindow.popup(20, 20)
#        self.newwindow.set_usize(120, 120)
        self.newwindow.connect ("delete_event", self.destroy)
        self.newwindow.connect ("destroy", self.destroy)
        self.newwindow.activate_focus()
#        self.get_toplevel().add(self.newwindow)

        hbox = GtkHBox()
        lbl = GtkLabel('Install module') 
        hbox.pack_start(lbl,expand=FALSE) 
        lbl.show() 
	self.windowbox.pack_start(hbox,expand=FALSE) 
	hbox.show()
        hbox = GtkHBox()
        lbl = GtkLabel('Either select a module:')
        hbox.pack_start(lbl,expand=FALSE) 
        lbl.show() 
	self.windowbox.pack_start(hbox,expand=FALSE) 
	hbox.show()

        scrolled_window = GtkScrolledWindow()
        scrolled_window.set_policy (POLICY_AUTOMATIC, POLICY_AUTOMATIC);
	self.addcl.column_titles_active()
	scrolled_window.add(self.addcl)
	self.addcl.show()
	self.windowbox.pack_start(scrolled_window, TRUE, TRUE, 0)
        scrolled_window.show()

        hbox = GtkHBox()
        lbl = GtkLabel('Or select it with the search function:') 
        hbox.pack_start(lbl,expand=FALSE) 
        lbl.show() 
	self.windowbox.pack_start(hbox,expand=FALSE) 
	hbox.show()
        hbox = GtkHBox()
        lbl=GtkLabel('Search:') 
        hbox.pack_start(lbl,expand=FALSE) 
        lbl.show() 
        self.searchname = GtkEntry()
        self.searchname.set_text('')
        hbox.pack_end(self.searchname)
	self.searchname.show()
	self.windowbox.pack_start(hbox, expand=FALSE)
	hbox.show()

        hbox = GtkHBox(FALSE)
        lbl=GtkLabel('') 
        hbox.pack_start(lbl, fill=FALSE, expand=TRUE)
        lbl.show() 
        button1=GtkButton(label='OK')
        button1.connect('clicked', self.call_insmod)
        hbox.pack_start(button1, fill=FALSE, expand=TRUE)
	button1.show() 

        button2=GtkButton(label='Cancel')
        button2.connect('clicked', self.cancel_edit)
        hbox.pack_start(button2, fill=FALSE, expand=TRUE)
	button2.show() 

	self.windowbox.pack_end(hbox, expand=FALSE)
	hbox.show()

	self.windowbox.show()
        self.newwindow.hide()

    def callback_remove(self, button1):
	self.debug('1')  
	if 0!= len (self.interest[:]):
	   self.debug('2')  
	   data = self.interest[0]
  	   if 3 > self.rmmod(self.loaded[data][0]) :
	      self.debug('3 data: %s'%data)
	      self.initloaded()
	      self.debug('5')  
	   self.debug('6')  
           self.redraw()
        self.debug('7')  

    def debugstart(self):
	sys.stdout.flush()
	sys.stderr.flush()
	print '\n\n\n\n\n\n\n\n'
	sys.stdout.flush()
        self.add(self.dbox) 
        self.dbox.show() 

    def debug(self, text):
	 sys.stderr.flush()
#        if self.dbox:
#            print text
#	    sys.stderr.flush()
#	    hb = GtkHBox(homogeneous=FALSE)
#            lbl = GtkLabel(str(text)) 
#            hb.pack_start(lbl,expand=FALSE)
#            self.dbox.pack_start(hb,expand=FALSE) 
#            lbl.show() 
#            hb.show() 

    def redraw(self):
        self.box = GtkVBox() 
        self.add(self.box) 
        self.box.show() 

        lbl = GtkLabel('Kernel Modules') 
        self.box.pack_start(lbl,expand=FALSE) 
        lbl.show() 

        scrolled_window = GtkScrolledWindow()
        scrolled_window.set_policy (POLICY_AUTOMATIC, POLICY_AUTOMATIC);
	scrolled_window.add(self.mycl)
	self.mycl.show()
	self.box.pack_start(scrolled_window, TRUE, TRUE, 0)
        scrolled_window.show()

        hbox = GtkHBox()
	self.box.pack_start(hbox, FALSE, TRUE, 0)
	hbox.show()

        hb = GtkHBox(FALSE)
        button1=GtkButton(label='Remove')
	button1.signal_connect('clicked', self.callback_remove)
        hb.pack_start(button1, fill=FALSE, expand=FALSE)
	button1.show() 
        button2=GtkButton(label='Add New')
        hb.pack_start(button2, fill=FALSE, expand=FALSE)
	button2.signal_connect('clicked', self.call_add)
	button2.show() 
  	self.box.pack_start(hb,expand=FALSE) 
	hb.show()

    def initloaded(self):
        self.interest=[]
        self.interest2=[]
        self.loaded=[]
        lineparselsmod = re.compile('^([^ \t]+)[ \t]+([^ \t]+)[ \t]+([^ \t]+)[ \t]*([^\t]*)$', re.IGNORECASE)

        fin = open('/proc/modules', 'r')  
        while 1:
           lines = fin.readlines(8*1024)
           if not lines: break
           for line in lines:
#                self.debug('  {%s}' % line)
		foundgoodline = lineparselsmod.search(line)
         	if foundgoodline:
#		   self.debug('loaded: %s %s' %(foundgoodline.group(1), foundgoodline.group(2)))
                   a = [foundgoodline.group(1), foundgoodline.group(2), foundgoodline.group(3), foundgoodline.group(4)]
		   self.loaded.append(a)
        fin.close()

	self.mycl.clear()
	for i in self.loaded[:]:
	    if 4==len(i):
                self.mycl.append((i[0], i[1], i[2], i[3]))
 
    def __init__(self): 
 
        Applet.__init__(self) 

        self.dbox = GtkVBox() 
#	self.debugstart()
	self.mycl = GtkCList(4, ('Module', 'size', 'count', 'referring'))
        self.mycl.set_column_width(0, 70)
        self.mycl.set_column_width(1, 40)
        self.mycl.set_column_width(2, 20)
        self.mycl.set_column_width(3, 70)
#	self.mycl.set_selection_mode(GTK_SELECTION_SINGLE)
	self.mycl.signal_connect('select_row', self.select_row)
	self.mycl.signal_connect('unselect_row', self.unselect_row)
	self.addcl = GtkCList(2, ('Location', 'Name'))
        self.addcl.set_column_width(0, 140)
        self.addcl.set_column_width(1, 70)
#	self.addcl.set_selection_mode(GTK_SELECTION_SINGLE)
	self.addcl.signal_connect('select_row', self.select_add_row)
	self.addcl.signal_connect('unselect_row', self.unselect_add_row)
	self.initloaded()
	self.initbasedir()
	self.inittree()

	self.redraw()
        self.makeaddwin()
#	self.addwin()

    def save(self,msgbox=FALSE): 
        import os 


        fout = open('/etc/modules', 'w')
	for a in self.loaded[:] :
          fout.write('%s\n' % a[0])
        fout.close() 

        ret = Applet.save(self,msgbox) 
 
applet_instance = applet() 
